require 'docker'

module Philae
  class DockerProbe
    attr_reader :name

    def initialize(name, endpoint = '/var/run/docker.sock', options = nil)
      @name = name
      @endpoint = endpoint
      @docker_options = options
    end

    def check
      Docker.url = @endpoint
      Docker.options = @docker_options if !@docker_options.nil?
      begin
        Docker::Container.all
      rescue
        return { healthy: false, comment: 'Unable to communicate with docker' }
      end

      return { healthy: true, comment: '' }
    end
  end
end
