require 'mongo'

# Philae::MongoProbe tries to connect to the given URI and list the collection names. The URI must
# be in the form `mongodb://[username:password@]host1[:port1][,host2[:port2],...[,hostN[:portN]]][/[database][?options]]`
module Philae
  class MongoProbe
    attr_reader :name

    def initialize(name, uri)
      @name = name
      @uri = uri
    end

    def check
      begin
        @client ||= Mongo::Client.new(@uri, max_read_retries: 1)
        db = @client.database
        db.collection_names
        @client.close
      rescue
        return { healthy: false, comment: 'Unable to contact mongo' }
      end

      return { healthy: true, comment: '' }
    end
  end
end
