require File.join File.dirname(__FILE__), 'http_probe.rb'

module Philae
  class NSQProbe < HttpProbe
    def self.new_from_env(name, opts = {})
      if ENV["NSQD_TLS"] == "true"
        return self.new(name, ENV["NSQD_HOST"], ENV["NSQD_HTTP_PORT"], {
          cert: ENV["NSQD_TLS_CERT"],
          key:  ENV["NSQD_TLS_KEY"],
          ca:   ENV["NSQD_TLS_CACERT"],
        }, opts)
      else
        return self.new(name, ENV["NSQD_HOST"], ENV["NSQD_HTTP_PORT"])
      end
    end

    def initialize(name, host, port = 4151, tls_context = nil, opts = {})
      @name = name
      scheme = "http"
      if !tls_context.nil?
        scheme = "https"
      end
      @uri = "#{scheme}://#{host}:#{port}/ping"
      @tls_context = tls_context
      @timeout = opts.fetch(:timeout, 5)
    end
  end
end
