module Philae
  class Prober
    def initialize
      @probes = []
    end

    def add_probe(probe)
      @probes << probe
    end

    def check
      probes_status = @probes.map do |probe|
        status = probe.check
        { name: probe.name, healthy: status[:healthy], comment: status[:comment] }
      end

      global = probes_status.all? do |probe|
        probe[:healthy]
      end

      return { healthy: global, probes: probes_status }
    end
  end
end
